with Ada.Real_Time; use Ada.Real_Time;
with system; use system;
with device_register_types; use device_register_types;
with co_sensor_rtatt; use co_sensor_rtatt;
with operator_console; use operator_console;
with data_logger; use data_logger;
package body CO_sensor is

  CO_present : CO_reading;
  -- define control and status register
  -- for the CO ADC
  --Control_reg_addr : constant Address := 16#AA1C#
  --Data_reg_addr : constant Address := 16#AA1E#
  COcsr : device_register_types.csr;
  --for COcsr'addres use Control_reg_addr;
  -- define the data register
  COdbr : CO_reading;
  --for COdbr'address use Data_reg_addr;
  now : Time;

  --procedure PERIODIC_CODE is separate;
  --procedure initialise is separate;
--separate(CO_sensor)
procedure initialise is
begin
  -- enable device
  cocsr.device := D_enabled;
end initialise;


--separate(CO_sensor)
procedure PERIODIC_CODE is
begin
  COcsr.operation := set; -- start conversion
  now := clock;  -- wait for conversion
  loop
    exit when clock >= now + milliseconds(100);
  end loop;
  if not COcsr.done then
    operator_console.alarm(CO_DEVICE_ERROR);
  else
    -- read device register for sensor value  
    CO_present := COdbr;     
    if CO_present > CO_HIGH then
      operator_console.alarm(HIGH_CO);
    end if;
    data_logger.CO_log(CO_present);
  end if;
end PERIODIC_CODE;

  task THREAD is
    PRAGMA PRIORITY(co_sensor_rtatt.thread_priority);
  end thread;

  task body THREAD is
    T: TIME;
    PERIOD : Time_span := co_sensor_rtatt.period;
  begin
    T:= clock;
    initialise;
    loop
      PERIODIC_CODE;
      T := T + PERIOD;
      delay until(T);
    end loop;
  end THREAD;
end CO_sensor;

