package device_register_types is

  word : constant := 2;      -- two bytes in a word
  one_word : constant := 16; -- 16 bits in a word
  -- register field types
  type device_error is (clear, set);
  type device_operation is (clear, set);
  type interrupt_status is (I_disabled, I_enabled);
  type device_status is (D_disabled, D_enabled);

  -- register type itself
  type csr is
    record
      error_bit  : device_error;
      operation  : device_operation;
      done       : boolean;
      interrupt  : interrupt_status;
      device     : device_status;
    end record;
  -- bit representation of the register field
  for device_error use (clear => 0, set => 1);
  for device_operation use (clear => 0, set => 1);
  for interrupt_status use (I_disabled => 0,
                            I_enabled => 1);
  for device_status use (D_disabled => 0,
                         D_enabled => 1);
  for csr use
    record at mod word;
      error_bit  at 0 range 15 ..15;
      operation  at 0 range 10 ..10;
      done       at 0 range 7 .. 7;
      interrupt  at 0 range 6 .. 6;
      device     at 0 range 0 .. 0;
    end record;
  for csr'size use one_word;
end device_register_types;
