with Ada.Real_Time; use Ada.Real_Time;
with device_register_types; use device_register_types;
with system; use system;
with water_flow_sensor_rtatt; use water_flow_sensor_rtatt;
with motor; use motor;
with operator_console; use operator_console;
with data_logger; use data_logger;
package body water_flow_sensor is

  flow : Water_flow := No;
  current_pump_status, last_pump_status : pump_status := off;

  -- define control and status register
  -- for the flow switch
    -- define control and status register
    -- for the motor
  --Control_reg_addr : constant Address := 16#AA14#;
  wfcsr : device_register_types.csr;
  --for wfcsr'address use Control_reg_addr;

  procedure initialise is
  begin
    -- enable device
    wfcsr.device := D_enabled;
  end initialise;

  procedure PERIODIC_CODE is
  begin
    current_pump_status := motor.request_status;
    if (wfcsr.operation = set) then 
      flow :=  yes;
    else
      flow := no;
    end if;
    if current_pump_status = on and  
        last_pump_status = on and flow = no  then
      operator_console.alarm(PUMP_DEAD);
    elsif current_pump_status = off and  
        last_pump_status = off and flow = yes  then
      operator_console.alarm(PUMP_DEAD);
    end if; 
    last_pump_status := current_pump_status;
    data_logger.water_flow_log(flow);
  end PERIODIC_CODE;

  task THREAD is
    pragma priority(water_flow_sensor_rtatt.thread_priority);
  end thread;

  task body THREAD is
    T: TIME;
    PERIOD : time_span := water_flow_sensor_rtatt.period;
  begin
    T:= clock;
    initialise;
    loop
      periodic_code;
      T := T + PERIOD;
      delay until(T);
    end loop;    
  end THREAD;

end water_flow_sensor;
